/*
 Copyright (C) 2010-2017 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "cicons.h"

typedef struct TPicCache {
  struct TPicCache *next;
  TPic pic;
  const char *zico;
} TPicCache;

static TPicCache *PicCache = NULL;

#ifdef MEM_CHK
static bool AtExitOk;

static void AppAtExit() {
  TPicCache *pch;

	while (PicCache) {
	    pch = PicCache;
	    PicCache = pch->next;
	    xfree(pch);
	}
}
#endif

TPic *GetDisZIcon(const char *zico) {
  TPicCache *pch, **ppch;

	if (!zico || !*zico) return NULL;
	pch = PicCache;
	while (pch && (pch->zico != zico)) {
	    pch = pch->next;
	}
	if (pch) return &pch->pic;

	pch = xcalloc(sizeof(TPicCache));
	pch->zico = zico;
	if (!CreateAHicoDisPic(zico, &pch->pic)) {
	    xfree(pch);
	    return NULL;
	}

#ifdef MEM_CHK
	if (!AtExitOk) {
	    AtExitOk = true;
	    pp_void_add((void*)&AppProcAtExit, 1, AppAtExit);
	}
#endif

	ppch = &PicCache;
	while (*ppch) {
	    ppch = &(*ppch)->next;
	}
	*ppch = pch;
	return &pch->pic;
}
