/*
 Copyright (C) 2010-2023 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

char *path_rel2abs(const char *rel, const char *basepath) {
  int l;
  char *cwd;
  const char *st;
  TPathInfo pathi;

	cwd = NULL;
	if (!rel) {
	    if (basepath) cwd = pcdup(basepath); else cwd = xgetcwd(false);
	} else {
	    get_PathInfo(rel, &pathi);
	    if (!basepath) {
		if (pathi.fu & pathi_rel) cwd = xgetcwd(true);
	    } else if (pathi.fu & pathi_rel) {
		st = NULL;
		l = pclen(basepath);
		if (!l || TestNoSlash(basepath[l-1])) st = S_SLASH;
		cwd = pcadd(basepath, st);
	    }
	    ppcadd(&cwd, rel);
	}

//	slash_korr(cwd, false);
	get_PathInfo(cwd, &pathi);
	dotdot_scan(pathi.path_anf_s);

//#ifdef _OS_WIN32
//	slash_korr(cwd, (pathi.fu & (pathi_SMB|pathi_RA_SMB)) || (pathi.fu & pathi_Local));
//#endif /* ! _OS_WIN32 */
	return cwd;
}

