/*
 Copyright (C) 2010-2024 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

/* **argv +4 items */
void cmdtoargs(const char *cmd, int *argc, char ***argv) {
#if 1
  char **args = NULL;
  char **ppmi;
  const char *indata;
  int count;

	count = 0;
	indata = cmd;
	while (indata && *indata) {
	    indata = GetTokenCmd(indata, NULL);
	    count++;
	}
	if (count > 0) {
	    args = xcalloc((count+5) * sizeof(void*));
	    ppmi = args;
	    indata = cmd;
	    while (indata && *indata) {
		indata = GetTokenCmd(indata, ppmi);
		ppmi++;
	    }
	}
	if (argc) *argc = count;
	*argv = args;
#else
  int lg;
  char **args = NULL;
  char **ppmi;
  const char *indata, *token;
  int count = 0;

	indata = cmd;
	while (indata && *indata) {
	    indata = pcGetToken(indata, &token, &lg);
	    if (token && *token) count++;
	}
	if (count > 0) {
	    args = xcalloc((count+5) * sizeof(void*));
	    ppmi = args;
	    indata = cmd;
	    while (indata && *indata) {
		indata = GetToken(indata, ppmi);
		ppmi++;
	    }
	}
	if (argc) *argc = count;
	*argv = args;
#endif
}

void args_free(char **argv) {
  char **ppmi;
	ppmi = argv;
	while (*ppmi) {xfree(*ppmi); ppmi++;}
	xfree(argv);
}
