/*
 Copyright (C) 2010-2016 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

#define MK_COMMA	1
#define MK_POS		(1<<1)
#define MK_NEG		(1<<2)

bool pcBeginIsInt(const char *s) {
  int Mk;
  const char *pc;

	if (!s) return false;
	pc = s;
	Mk = 0;
	while (*pc) {
	    if ((*pc >= '0') && (*pc <= '9')) {
		return true;

	    } else if (*pc == '-') {
		if (Mk & (MK_POS|MK_NEG)) return false;
		Mk |= MK_NEG; 

	    } else if (*pc == '+') {
		if (Mk & (MK_POS|MK_NEG)) return false;
		Mk |= MK_POS; 

	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) return false; //Leerzeichen am Anfang erlaubt

	    } else {
		return false;
	    }
	    pc++;
	}
	return false;
}

bool pcBeginIsFloat(const char *s) {
  int Mk;
  const char *pc;

	if (!s) return false;
	pc = s;
	Mk = 0;
	while (*pc) {
	    if ((*pc >= '0') && (*pc <= '9')) {
		return true;

	    } else if (*pc == '-') {
		if (Mk & (MK_COMMA|MK_POS|MK_NEG)) return false;
		Mk |= MK_NEG; 

	    } else if (*pc == '+') {
		if (Mk & (MK_COMMA|MK_POS|MK_NEG)) return false;
		Mk |= MK_POS; 

	    } else if ((*pc == '.') || (*pc == ',')) {
		if (Mk & (MK_COMMA)) return false;
		Mk |= MK_COMMA;

	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) return false; //Leerzeichen am Anfang erlaubt

	    } else {
		return false;
	    }
	    pc++;
	}
	return false;
}


