/*
 Copyright (C) 2010-2016 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void pctoUcase_fi(char *a, int fu) {
	if (!a) return;
#ifdef USE_CHAR_NOTAB
	while (*a) {
	    if (((byte)*a >= 'a') && ((byte)*a <= 'z')) *a -= 0x20;
	    a++;
	}
#else /* USE_CHAR_NOTAB */
  const byte *ct;

	switch (fu & FU_CASE_MASK) {
#ifdef USE_CHAR_ASCII
	case FU_CASE_ASCII: ct = (const byte*)u_ascii; break;
#endif
#ifdef USE_CHAR_iso8859_1
	case FU_CASE_8859_1: ct = (const byte*)u_iso8859_1; break;
#endif
	default:
	    ct = (const byte*)USE_CHAR_DEFAULT;
	}

	while (*a) {
	    *a = ct[(byte)*a];
	    a++;
	}
#endif /* !USE_CHAR_NOTAB */
}

void pctoUcaseASCII(char *a) {
	pctoUcase_fi(a, FU_CASE_ASCII);
}
