/*
 Copyright (C) 2010-2016 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

#define bNUM	1
#define bHEX	(1<<1)
#define bNEG	(1<<2)

int ppctoint_scan(const char **ppc, bool Scan) {
  int res, Mk;
  const char *pc;
	if (!ppc || !*ppc) return 0;
	pc = *ppc;
	Mk = res = 0;

	while (*pc) {
	    if (!Mk && (*pc == '0') && (pc[1] == 'x')) {
		Mk |= bHEX;
		pc++;
	    } else if ((*pc >= '0') && (*pc <= '9')) {
		Mk |= bNUM;
		if (Mk & bHEX) res <<= 4; else res *= 10;
		res += *pc & 0x0f;

	    } else if ((Mk & bHEX) && (((*pc >= 'A') && (*pc <= 'F')) || 
				       ((*pc >= 'a') && (*pc <= 'f')))) {
		res = (res << 4) + ((*pc - 7) & 0x0f);

	    } else if (*pc == '-') {
		if (Mk) break;
		Mk = bNEG;
		if ((pc[1] == '0') && (pc[2] == 'x')) {
		    Mk |= bHEX;
		    pc += 2;
		}
	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) break; //Leerzeichen am Anfang erlaubt
	    } else if (!Mk && (*pc == '$')) {
		Mk = bHEX;
	    } else {
		if (!Scan || Mk) break;
	    }
	    pc++;
	}
	if (Mk & bNEG) res = -res;
	*ppc = pc;
	return res;
}

int ppctoint(const char **ppc) {
	return ppctoint_scan(ppc, False);
}

int pctoint(const char *pc) {
  const char *cpc = pc;
	return ppctoint_scan(&cpc, False);
}

int pctoint_scan(const char *pc) {
  const char *cpc = pc;
	return ppctoint_scan(&cpc, True);
}
