/*
 Copyright (C) 2010-2024 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void QuickSort_ic32(Tic32 *PL, int L, int R, int fu, int (*CompareFunction)(Tic32 a, Tic32 b, int fu)) {
  int I, J, P, pm;

	while (L < R) {
	    I = L;
	    J = R;
	    P = (I + J) >> 1;
loopB:
	    while (CompareFunction(PL[I], PL[P], fu) < 0) I++;
	    while (CompareFunction(PL[J], PL[P], fu) > 0) J--;
	    if (I <= J) {
		if (I < J) {
		    pm = PL[I].i; PL[I].i = PL[J].i; PL[J].i = pm;
		}
		if (P == I) P = J; else if (P == J) P = I;
		I++; J--;
		if (I <= J) goto loopB;
	    }
	    if (L < J) QuickSort_ic32(PL, L, J, fu, CompareFunction);
	    L = I;
	}
}


