/*
 Copyright (C) 2010-2024 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

const char *GetTokenCmd(const char *indata, char **token) {
  int st;
  const char *t, *ta, *result;
  char *rtoken, *rt;
  bool mk;

	if (token) *token = NULL;
	if (!indata) return NULL;
	t = indata;
	while (*t && ((byte)*t <= 0x20)) t++;
	if (!*t) return NULL;

	ta = t;
	mk = false;
	while (*t) {
	    if (*t == '"') {
		mk = mk == false;
	    } else if ((*t == '\\') && (t[1] == '"')) {
		t++;
	    }
	    if (!mk && ((byte)*t <= 0x20)) break;
	    t++;
	}
	result = t;
	while (*t && ((byte)*t <= 0x20)) t++;
	if (!*result) result = NULL;

	if (token) {
	    rtoken = xmalloc(t - ta + 1);
	    *token = rtoken;
	    t = ta;
	    rt = rtoken;
	    while (*t) {
		st = 0;
		if (*t == '"') {
		    mk = mk == false;
		} else {
		    if ((*t == '\\') && (t[1] == '"')) t++;
		    st++;
		}
		if (!mk && ((byte)*t <= 0x20)) break;
		if (st) {*rt = *t; rt++;}
		t++;
	    }
	    *rt = 0;
	}
	return result;
}
