/*
 Copyright (C) 2010-2016 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

static void SetItem_mi(TComboBox *cb, TMenuItem *mi) {
	if (mi && (cb->popup->SelItem != mi)) {
	    cb->SelItem = mi;
	    cb->popup->SelItem = mi;
	    TMenu_DoClick(cb->popup, 0, false);
	}
}

void TComboBox_SetItem_mi(TComboBox *cb, TMenuItem *mi) {
  TMenuItem *pmi = cb->popup->MenuItem;
	while (pmi && (pmi != mi)) pmi = pmi->next;
	SetItem_mi(cb, pmi);
}

void TComboBox_SetItem(TComboBox *cb, int idx) {
  TMenuItem *mi = cb->popup->MenuItem;
  int i;
	if ((idx < 0) || !mi) {
	    cb->SelItem = NULL;
	    cb->popup->SelItem = NULL;
	    if (cb->ReadOnly) {
		SetCaption((TWins*)cb, NULL);
	    }
	} else {
	    i = 0;
	    while (mi && (idx > i++) && mi->next) mi = mi->next;
	    SetItem_mi(cb, mi);
	}
}

void TComboBox_SetNextItem(TComboBox *cb) {
  TMenuItem *mi = cb->popup->SelItem;
	if (mi && mi->next) {
	    SetItem_mi(cb, mi->next);
	} else { 
	    SetItem_mi(cb, cb->popup->MenuItem);
	}
}

void TComboBox_SetPrevItem(TComboBox *cb) {
  TMenuItem *mi = cb->popup->SelItem;
	if (!mi) {
	    SetItem_mi(cb, cb->popup->MenuItem);
	} else if (mi->prev) {
	    SetItem_mi(cb, mi->prev);
	} else {
	    while (mi->next) mi = mi->next;
	    SetItem_mi(cb, mi);
	}
}

int TComboBox_GetItem(TComboBox *self, const char *s) {
  TMenuItem *mi;
  int result;

	if (!s || !*s) return TCB_NO_ITEM;
	result = 0;
	mi = self->popup->MenuItem;
	while (mi && !pccmp(mi->s, s)) {
	    mi = mi->next;
	    result++;
	}
	if (!mi) return TCB_NO_ITEM;
	return result;
}

TMenuItem *TComboBox_GetSelItem(TComboBox *self) {
	if (!self) return NULL;
	return self->popup->SelItem;
}
