/*
 Copyright (C) 2010-2017 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tlineedit.h"

#ifdef MEM_CHK
static bool AtExitOk;

static void AppAtExit() {
  TPlugIn_KeyDown *plug;

	while (TLineEdit_keyplugin_Global) {
	    plug = TLineEdit_keyplugin_Global;
	    TLineEdit_keyplugin_Global = plug->next;
	    Tfree(plug);
	}
}
#endif


void TLineEdit_AddKeyDownPlugIn(TLineEdit *le, TPlugIn_KeyDown *plug) {
	if (le) {
	    plug->next = le->PlugIn_KeyDown;
	    le->PlugIn_KeyDown = plug;
	} else {
	    plug->next = TLineEdit_keyplugin_Global;
	    TLineEdit_keyplugin_Global = plug;
#ifdef MEM_CHK
	    if (!AtExitOk) {
		AtExitOk = true;
		pp_void_add((void*)&AppProcAtExit, 1, AppAtExit);
	    }
#endif
	}
}

