/*
 Copyright (C) 2010-2024 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#ifdef USE_DECOR
#include "image.h"
#endif
#include "alsa_mixer.h"

#if USE_ALSA_BEEP
#include <X11/XKBlib.h>
//#include <X11/extensions/XKBfile.h>
//#include <X11/extensions/XKBbells.h>
#endif

#define TCSelf TpnlRegler
typedef struct TpnlRegler {
  AlgTWins
  TScrollBar *sbVol;
  TScrollBar *sbBal;
  int headpicno;
  Tmix_elem *elem;
  bool ev_stop;
} TpnlRegler;
#undef TCSelf

#define TCSelf TMainForm
typedef struct TMainForm {
  AlgTForm
  TSound_MIXER *alsa_mix;
  TPageControl *pgc;
  TPage *pgBase;
  TPage *pgSetup;
  TpnlRegler *prMaster;
  TpnlRegler *prPCM;
  TpnlRegler *prSpeaker;
#if USE_ALSA_BEEP
  TpnlRegler *prAlsaBeep;

  TChkBox *cbAlsaBeep;
  TWins *lblAlsaBeepFreq;
  TDVal *dvAlsaBeepFreq;
  TWins *lblAlsaBeepTime;
  TDVal *dvAlsaBeepTime;
  TButton *buAlsaBeep;
  TSound_Beep bp;
  unsigned long xkb_eventMask;
  int xkbEventCode;
#endif
  bool Bal_LR;
} TMainForm;
#undef TCSelf

extern TPic *get_MixerIcon(int idx);
