/*
 Copyright (C) 2010-2017 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __AH_FORM_LC_H__
#define __AH_FORM_LC_H__    1

#include "appXbase.h"
#include "math_line.h"
#include "RLC.h"
#include "tlineedit.h"

#define wtyp_TFormR		wtyp_USER_Form + 1
#define wtyp_TFormL		wtyp_USER_Form + 2
#define wtyp_TFormC		wtyp_USER_Form + 3
#define wtyp_TFormDigA		wtyp_USER_Form + 4
#define wtyp_TFormDigB		wtyp_USER_Form + 5

#ifdef FILTER_PULS
#define wtyp_TFormPuls		wtyp_USER_Form + 6

#define RLC_RS		1
#define RLC_LS		(1<<1)
#define RLC_CS		(1<<2)
#define RLC_RP		(1<<3)
#define RLC_LP		(1<<4)
#define RLC_CP		(1<<5)
#endif



#define AlgTFormRLC const char *Gruppe; \
  char *sOpt; \
  char *sXY; \
  void (*OnChange)(struct TFormRLC* self); \
  void (*OnSync)(struct TFormRLC* self, int val); \
  void (*FormSave)(struct TFormRLC* self); \
  void (*SaveData)(struct TCSelf *self, TpcIni *ini); \
  void (*LoadData)(struct TCSelf *self, TpcIni *ini); \
  void (*Update)(struct TCSelf *self, float val, int ufu); \
  void (*SetFreq)(struct TFormRLC* self, float val);

#define TCSelf TFormRLC
typedef struct TFormRLC {
  AlgTForm
  AlgTFormRLC;
} TFormRLC;
#undef TCSelf

#define TCSelf TFormC
typedef struct TFormC {
  AlgTForm
  AlgTFormRLC;
  const char *sC;
  
  TWins *pnl1;
  TWins *pnlC;
  TDVal *C;
  TWins *pnlOpt;
  TDVal *Rs;
  TDVal *Ls;
  TDVal *Rp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbRs;
  TChkBox *cbRp;
  TChkBox *cbLs;
//  TChkBox *cbTC;
  TScrollBar *sbTC;
  TDVal *TCmin;
  TChkBox *cbTCsync;
  int val_sync;
  TDVal *TC;
  TRLC rlc;

  TDVal *exDVal;

#ifdef FILTER_PULS
  dword rlcex;
  float ps_add;

  double U;
  double I;
  double Z0;

//	double Uges;
#if FILTER_PULS_OLD
  double Puls_Z;
  double Uc;
  double Uadd, Uz;
  double RC, RC_Ls;
#endif
  double RC_Rs, RC_Rp;
  TCoC coC;
  TCoL coLs;

#endif

} TFormC;
#undef TCSelf

TFormC *Create_Form_C(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sC, TDVal *exDVal, float val);
void Form_C_math(TFormC *fC, float w);
void Form_C_sync(TFormRLC *fRLC, TFormC *fC, int val);
#ifdef FILTER_PULS
void Form_C_Clr(TFormC *self, float ps_add);
void Form_C_Puls_math(TFormC *self, double R_Load, double U_Load);
#endif

#define TCSelf TFormL
typedef struct TFormL {
  AlgTForm
  AlgTFormRLC;
  const char *sC;
  TWins *pnl1;
  TWins *pnlL;
  TDVal *L;
  TWins *pnlOpt;
  TDVal *Rs;
  TDVal *Cp;
  TDVal *Rp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbRs;
  TChkBox *cbRp;
  TChkBox *cbCp;
//  TChkBox *cbTL;
  TScrollBar *sbTL;
  TDVal *TLmin;
  TChkBox *cbTLsync;
  int val_sync;
  TDVal *TL;
  TRLC rlc;

  TDVal *exDVal;

  TChkBox *cbCs;
  TDVal *dvCs;

#ifdef FILTER_PULS
  dword rlcex;
  float ps_add;
#if FILTER_PULS_OLD
	double Puls_Z;
	double IL;
	double RL_t, RL_Cp;
	double LIadd;
	double Uz;
	double Uc;
	double Ul;
#endif
	double U;
	double I;
	double IRp;

	double RL_Rs, RL_Rp;
  TCoL coL;
  TCoC coCp;
#endif

} TFormL;
#undef TCSelf

TFormL *Create_Form_L(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sC, TDVal *exDVal, float val);
void Form_L_math(TFormL *fL, float w);
void Form_L_sync(TFormRLC *fRLC, TFormL *fL, int val);
#ifdef FILTER_PULS
void Form_L_Clr(TFormL *self, float ps_add);
void Form_L_Puls_math(TFormL *self, double R_Load, double U_Load);
double Form_L_Puls_get_U(TFormL *self, double R_Load);
#endif

#define TCSelf TFormR
typedef struct TFormR {
  AlgTForm
  AlgTFormRLC;
  const char *sR;
  TWins *pnl1;
  TWins *pnlR;
  TDVal *R;
  TWins *pnlOpt;
  TDVal *Ls;
  TDVal *Cp;
  TWins *pnlZ;
  TDVal *MHz;
  TDVal *Z;
  TChkBox *cbC;
  TChkBox *cbOptOn;
  TChkBox *cbLs;
  TChkBox *cbCp;
//  TChkBox *cbTR;
  TScrollBar *sbTR;
  TDVal *TRmin;
  TChkBox *cbTRsync;
  int val_sync;
  TDVal *TR;
  TRLC rlc;

  TDVal *exDVal;

} TFormR;
#undef TCSelf

TFormR *Create_Form_R(TWins *parent, const char *Caption, const char *Gruppe, 
			const char *sR, TDVal *exDVal, float val);
void Form_R_math(TFormR *fR, float w);
void Form_R_sync(TFormRLC *fRLC, TFormR *fR, int val);
#ifdef FILTER_PULS
void Form_R_Clr(TFormR *self);
#endif

void TFormRLC_Save(TFormRLC* fRLC);

#define TCSelf TFormDigA
typedef struct TFormDigA {
  AlgTForm
  AlgTFormRLC;
  const char *sF;

  TWins *pnl1;
  TWins *pnlX;
  TWins *pnlOpt;
  TWins *pnlZ;
//pnlX
  TDVal *dvX;
  TDVal *dvNr;
/* Panel Optionen */
  TLineEdit *le;
//pnlZ
  TChkBox *cbTX;
  TScrollBar *sbTX;
  TDVal *dvTX;
  TDVal *dvTXval;
  TChkBox *cbTXsync;
  int val_sync;
  TMathLineStruct *mls;

  TDVal *exDVal;

} TFormDigA;
#undef TCSelf

TFormDigA *Create_Form_DigA(TWins *parent, const char *Caption, 
		const char *Gruppe, const char *sF, TDVal *exDVal, float val);
void Form_DigA_sync(TFormRLC *fRLC, TFormDigA *mf, int val);

#ifdef FILTER_PULS

#define TRG_LH		0
#define TRG_HL		1


#define TRG_LH_V1	1
#define TRG_LH_V2	(1<<1)

#define TCSelf TFormPuls
typedef struct TFormPuls {
  AlgTForm
  void (*OnChange)(struct TFormPuls *self);
  const char *Gruppe;
  char *sXY;
  char *sOpt;

  TWins *pnl1;
  TWins *pnlT;
  TDVal *T;
  TDVal *Vdiv;


  TWins *pnlOpt;
  TDVal *dvVpp;
  TDVal *dvVus;
  TDVal *dvNs;
  TDVal *dvPp;

  TChkBox *cbVus;
  TChkBox *cbns;
  TChkBox *cbPp;

  TScrollBar *sbT;
//  TDVal *TCmin;
//  TChkBox *cbTCsync;

  TWins *pnlZ;
  TDVal *dvOutAmpl;
  TComboBox *cobTrg;
  TDVal *dvTrgNs;
  TDVal *dvTrgVus;
  TChkBox *cbAzIn;

  float ns_add, ns, ampl, nsPp, Vpp_add;
  float trg_V1k, trg_V2k;
  int trg_flag;
  float trg_V1, trg_V2;
  float trg_V1_ns, trg_V2_ns;

  bool istgl;
} TFormPuls;
#undef TCSelf

TFormPuls *Create_Form_Puls(TWins *parent, const char *Caption, 
			const char *Gruppe, const char *sC);

void TFormPuls_SaveData(TFormPuls *self);
void TFormPuls_SavePosOnOff(TFormPuls *self);
float TFormPuls_get_ps_add(TFormPuls *self, int count, int k);
float TFormPuls_get_ampl(TFormPuls *self);
void TFormPuls_SetTrigV(TFormPuls *self, float U, int fu);
void TFormPuls_ChkTrigV(TFormPuls *self, float U, int idx);

#endif /* FILTER_PULS */



#endif /* __AH_FORM_LC_H__ */
